;;; A few fns to help LaTeXise song formats.  Simon Marshall.
;;; S.Marshall@cs.hull.ac.uk


(defun album-name ()
  (interactive)
  (save-excursion
    (goto-char (point-min))
    (while (search-forward "@ALBUM: " (point-max) t)
      (delete-region (point) (progn (beginning-of-line) (point)))
      (insert "\\newrecord{")
      (delete-horizontal-space)
      (capitalize-region (point) (progn (end-of-line) (point)))
      (delete-horizontal-space)
      (insert "}")))
)


(defun song-name ()
  (interactive)
  (save-excursion
    (goto-char (point-min))
    (while (search-forward "@SONG: " (point-max) t)
      (delete-region (point) (progn (beginning-of-line) (point)))
      (insert "\\newsong{")
      (delete-horizontal-space)
      (capitalize-region (point) (progn (end-of-line) (point)))
      (delete-horizontal-space)
      (insert "}")))
)


(defun verse-song ()
  (interactive)
  (save-excursion
    (album-name)
    (song-name)
    (goto-char (point-min))
    (while (= (forward-line) 0)
      (end-of-line)
      (delete-horizontal-space))
    (goto-char (point-min))
    (while (re-search-forward "[a-zA-Z0-9.,:?!]\n[^\n]" (point-max) t)
      (end-of-line 0)
      (insert " \\\\"))
    (goto-char (point-min))
    (while (search-forward "_" (point-max) t)
      (let ((begin (1- (point))))
	(skip-chars-forward "_")
	(delete-region begin (point))
	(insert "\\ldots\\ ")))
    (goto-char (point-min))
    (while (search-forward "\"" (point-max) t)
      (backward-delete-char 1)
      (LaTeX-insert-quote nil))
    (goto-char (point-min))
    (replace-string ">From" "From")
    (goto-char (point-min))
    (replace-string " - " "---")
    (goto-char (point-min))
    (replace-string "..." "\\ldots\\ "))
)
